C.......................................................Mar 2019
C Calculate cross-correlation of 2 arrays given lag=-6,-5,-4,...-1,0,1,...5, 6 hrs
C Model of Prpb. W+, W- versus Dst
C 
      program crosslag
C      output	cmaprms2.txt
C
      DIMENSION dinp(73,3)
C	+,x(73),y(73),z(73)
	+,x(37),y(37),z(37)
	character*45 infilep,infilen,infiled,outfile
	character*14 title
c
c
C Intense storms
c+	infilep='mpos1.txt'
c+	infilen='mneg1.txt'
c+	infiled='mdst1.txt'
C Moderate storms
	infilep='mpos2.txt'
	infilen='mneg2.txt'
	infiled='mdst2.txt'

	outfile='crosslagw.txt'
   21	format(1X,F9.4,2(4X,F6.5))
C
   18	OPEN(11,FILE=infilep,action='READ')
      OPEN(12,FILE=infilen,action='READ')
	OPEN(13,FILE=infiled,action='READ')
	OPEN(10,FILE=outfile,ACCESS='APPEND')
	read(11,*) title
      read(12,*) title
	read(13,*) title
C
	do i=1,73
	read(11,*) dinp(i,3) ! W+
	read(12,*) dinp(i,2) ! W-
	read(13,*) dinp(i,1) ! Dst
	enddo
C
      close(unit=11)
	close(unit=12)
	close(unit=13)
C
Crem	do n=1,73
	do n=1,37
	x(n)=dinp(n+12,1)
	enddo
Crem	do n=1,73
	do n=1,37
c+	y(n)=dinp(n+12,2)	   ! W- probability
	y(n)=dinp(n+12,3)	   ! W+ probability
	enddo

Cycle on lag (delay of Wp after Dst)
	irun=0
  119	continue
	irun=irun+1 
      DO 120 lag=0,12
Crem	nrun=73-lag
	nrun=37-lag
	sx=0.
	sy=0.
	do jj=1,nrun
	sx=sx+x(jj)
	z(jj)=y(jj+lag)
	sy=sy+y(jj)
	enddo
	sx=sx/nrun
	sy=sy/nrun
	sum1=0.
	sum2=0.
	sum3=0.
	do jj=1,nrun
	sum1=sum1+(x(jj)-sx)*(z(jj)-sy)
      sum2=sum2+(x(jj)-sx)**2
      sum3=sum3+(y(jj)-sy)**2
	enddo
	cxy=sum1/sqrt(sum2*sum3)
	write(*,22) irun,nrun,lag,cxy,x(1),y(1),z(1)
	write(10,22) irun,nrun,lag,cxy,x(1),y(1),z(1)
  120	continue
C
  22	format(1X,3(1X,I2),1X,F7.3,3(1X,F8.3))
	if (irun.eq.1) then
Crem	do m=1,73
      	do m=1,37
	z(m)=dinp(m+12,1)
c+	x(m)=dinp(m+12,2)  !W-
	x(m)=dinp(m+12,3) ! W+
	y(m)=z(m)
	enddo
	goto 119
	else
	 GOTO 33
	endif

    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
   33	continue
  98	close(unit=10)
      write(*,*) infilep,infilen,infiled,outfile
      pause ' ' 
   34   STOP
       END

