      program devgeo14s
C........................................................Mar. 2021
C W(GTEC) regarding Shubin-GTEC monthly median
C
C........................................................Jan. 2019
C
C W-index for map in geogr. coords. Glat=-87.5:2.5:87.5, glong=-180:5:180.
C
C........................................................Oct. 2015
C Avoid <a> and <b> extrapolation
C........................................................June 2014
C........................................................Dec. 2013
C results => /graf/
C........................................................Nov.2012
C for JPL hourly data
C........................................................Oct. 2012
C Include subwp3 to update file of Wp index
C........................................................Apr. 2012
C Maps in IONEX format
C
C........................................................Jan. 2012
C Correct transition from month-to-month
C
C  ......................................................Dec.2011
C  Arrange subfur forecast of fcF2, hcF2, tec, Wp maps for two days ahead
C
C .......................................................Nov.2011
C
C   Call submapdy to produce daily maps of foF2, hmF2, TEC, and W-index
C........................................................Aug.2011
C For 1h_input IONEX-based TECmap files: d:\web\dtc\YY\MM\tcMMDDUT.fYY
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C Input: prec_mn (all days) into lines 1:7(last day of prec_mn) and current_mn (till given day=>8 line) for fixed UT
C
C Change+++ Produce median for 7 preceding days (instead of 27 prec days)
C
C OUTPUT : W index global map : d:\web\dtw\YY\MM\tcMMDDUT.wYR		!W(TEC)
C		 W index global map : d:\web\dfw\YY\MM\fcMMDDUT.wYR		!W(foF2)
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C
C
C T.L.Gulyaeva .................................................July 2007
C
C FORMAT from 27 prec. days
C Include logarithmic scale indices -4,  -3,    -2,    -1,0, 1,    2,    3,   4
C Equivalent to log10(TEC/TECmed)= <-.301, -.155, -.045   0,  0.45, .155, .301 >
C                              
C Ref. Gulyaeva T.L. Logarithmic scale of ionospheric disturbances,
C      Geomagn.and Aeronomy, 1996, 36, 1, 160-163, 1996.
C
      DIMENSION IM(12)
C//	+,X1(31),X2(31)
C//     +,DA(0:28,0:72,71) ! TEC 7prec_days+curr_day=8,longs=0:72,lats=71
     +,XMED(0:72,71,0:23),DEV(0:72,71) ! Median for all UT=0,...,23
C//     +,FU1(24),FU2(24)
	dimension rx(0:72)
	integer*4 IRES(0:72,71),idev(0:72,71)
C//	integer*2 IYR,IMN,IDY,IUT
	+,IDY1,IDY2,nndy !Maps available for idy1 to idy2
     +,imni,iyri
	CHARACTER*48 INFILE2,OUTFILE1,OUTFILE2
	+,INFILE1  ! Read GTEC => median
	CHARACTER*2 AYR
C	CHARACTER*4 AYEAR
	+,AUT,AMN,ADY
	+,AMNI,ADY1
	CHARACTER*1 ft
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C//	COMMON   /CONST/UMR
C//	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie
C
C
C// 	 UMR=.0174533
C//      PHI=3.141593
Crem	ft='f'		!fcF2-map
      ft='t'  ! TEC-map
C
Crem	WRITE(*,*)' ENTER YR OF INPUT FILE=	'
Crem	read(*,17) AYR
        
Cnorm	DO 698 iyear=1994,2020	  !norm
      iyear=2022          ! Temp
	iyr=iyear-iyear/100*100
C-	call blet4(iyear,AYEAR)
      call blet2(iyr,AYR)
CREM	AYR='15'
C-	AYR=AYEAR(3,4)
	write(*,*) AYR
   17 format (A2)
cc	write(*,17) ' YR=',ayr
	read(AYR,*) ryr
C	IYR=int(ryr)   ! current yr
	iyri=iyr
C
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
C
C//	WRITE(*,*)' ENTER CURRENT MN'
C//	READ(*,13) IMN
Crem	imn=01
   13 FORMAT(I2)
200   continue	  
C
C monthly cycle
       imn1=1
	imn2=12
	if (iyyyy.eq.2022) imn2=8
C
      DO 699 imn=imn1,imn2         ! MONTHHHHHHHHHHHHHHHHHHHHHHHHH
  177	call blet2(imn,amn)  ! current month
C		write(*,*) AMN
	AMNI=AMN
	imni=imn
C
C//	WRITE(*,*)' ENTER IDY1,idyend'
C//	READ(*,13) IDY1,idyend
       idy1=1
	idy2=im(imn)
C

C?? 255	idy2=idy1
      call blet2(idy1,ady1)
C
	lda1=ndoy(iyr,imn,idy1)
C
C
	outfile2='d:\web\gtc\YY\MM\wgMMDDUT.sYY'   ! current mn
c//	outfile(9:9)=ft
c//	outfile(18:18)=ft
	outfile2(12:13)=ayr
	outfile2(15:16)=amn
	outfile2(28:29)=ayr
	outfile2(20:21)=amn
	outfile1=outfile2
	outfile1(18:18)='d'
C
C  Avoid input of prec. month:
crem	nnd1=idy1-6
C//      ncnt=0        ! count of days 1,2,...,7   
C//      if (idy1.ge.7) goto 230	  ! goto input of current month
C
      infile1='d:\web\gtc\YY\MM\gtMM15UT.sYY'    ! 's' means Shub. Gtec
	call blet2(iyr,AYR)
	call blet2(imn,AMN)
	infile1(12:13)=ayr
	infile1(15:16)=amn
	infile1(20:21)=amn
	infile1(28:29)=ayr
C start reading GTEC=median for current mon  ======================================
C
  230	continue
	nndy=im(imn)	 ! end of current month
      DO kut=0,23
	call blet2(kut,AUT)
	infile1(24:25)=aut
       OPEN(10,file=infile1,action='READ')
	 DO lat=1,71
	     READ (10,107,END=239,ERR=2) (XMED(k,lat,kut),k=0,72) ! READ GTEC-med
	 ENDDO
  239	close(unit=10)
	ENDDO
C
  490 format(1X,' year=',I2,' month=',I2,' day=',I2,' ut=',I2)
      infile2='d:\web\dts\YY\MM\tcMMDDUT.jYY'    !  GIM-tec JPL geogr.
CC++
	idy=0
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy3, current month
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
      if (idy.gt.idy2) then
	goto 500 ! end of day-to-day processing 
	endif
	call blet2(idy,ADY)
	 	infile2(12:13)=ayr
  	infile2(28:29)=ayr
		infile2(15:16)=amn
 	infile2(20:21)=amn
	infile2(22:23)=ady
	outfile1(22:23)=ady	
       outfile2(22:23)=ady	
C++
C++  Rename file extension .re1 or ta* / tb* for prediction files
  700 format(A128)
  107	FORMAT(73(1X,F4.1))
C
C UT cycle			  +++++++++++++++++++++++
        DO 601 iut=0,23  ! UTTTTTTTTTTTTTTTTTTTTTT
	  call blet2(iut,AUT)
	infile2(24:25)=aut
	outfile1(24:25)=aut	
       outfile2(24:25)=aut	
	    		   
	INFILE2(27:27)='j'
		OPEN(10,FILE=INFILE2)
		OPEN(11,FILE=OUTFILE1)
	OPEN(12,FILE=OUTFILE2)
C
 704 	 continue
       do 600 ilat=1,71		  ! < LAT-BY-LAT	LATTTTTTTTTTTTTTTTT
cr	glat=glat+2.5
	READ (10,107,END=108,ERR=2) (rx(k),k=0,72)
C
cr	glon=-185.		! TEC at glon=-180,-185,...,180
	   do 114 m=0,72		 !<<<<<<<<<<<<<<<<<< LONNNNNNNNNNNNNN
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
C Calculation of W index for idy 
      xpar=rx(m)
	xmd=XMED(m,ilat,iut)
	devlog=0.
	call windex(xpar,xmd,devlog,iwind)
	DEV(m,ilat)=devlog
	IRES(m,ilat)=iwind
C-	amed=xmd
C-	if (ft.eq.'f') amed=sqrt(xmd)
	idev(m,ilat)=nint(dev(m,ilat)*1000.)
 114  CONTINUE        ! cycle M ~ glong		   !LONNNNNNNNNNNNNNNN
Crem 	WRITE(*,498) (IRES(K,ilat),K=0,72)
 	WRITE(12,498) (IRES(K,ilat),K=0,72)
Crem	WRITE(*,498) (IDEV(K,ilat),K=0,72)
	WRITE(11,498) (IDEV(K,ilat),K=0,72)
  600	CONTINUE			  !< LAT-BY-LAT			!LATTTTTTTTTTTTTTTTTT
C
C outout results+++++++++++++++++++++++++++++++++++
C
  108	close(UNIT=10)
	close(UNIT=11)
      close(UNIT=12)
  601 CONTINUE			  !UTTTTTTTTTTTTTTTTTTTTTTTT
C
C
c//  240	outfile1(22:23)=ady1	  !*************************************************
c//       outfile2(22:23)=ady1	
C++
C++  Rename file extension .re1 or ta* / tb* for prediction files
c//	outfile(19:19)='c'
      lda=ndoy(iyr,imn,idy) ! function to define day-of-year
C
crem 	WRITE(*,498) (IMED(K,ilat),K=0,72)
c== 	WRITE(113,498) (IMED(K,ilat),K=0,72)

C	
       if (idy.lt.idy2) GOTO 499        ! NEXT DAYYYYYYYYYYYYYYYYYYYYYY	 
 150	continue         ! 
C
 498  FORMAT(73(1X,I4))
c==		CLOSE(unit=113)
C

 202  CONTINUE
C
C =========================================
  500 continue   ! end day-by-day cycle     !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C//	imn=imni

  300 CONTINUE		! end UT cycle
C Combine UT maps into daily IONEX file including .txt, .txa, .txb files:
c//	call submapgj(1,iyr,imn,idy2,iyr3,imn3,idy3) ! foF2
c//	call submapgj(2,iyr,imn,idy2,iyr3,imn3,idy3) ! hmF2
c//	call submapgj(3,iyr,imn,idy2,iyr3,imn3,idy3) ! TEC
c//	call submapgj(4,iyr,imn,idy2,iyr3,imn3,idy3) ! W=index

            write(*,*) ' yr=',AYR,'  mn=',AMN,' dy1=',idy1,' dy2=',idy2 
C
CREM	call subws3g(AYRI,AMNI,IDY1,IDY2)
crem	if (idy2.lt.im(imn)) then
crem	idy1=idy1+1
crem	goto 255
crem	endif
C Combine UT maps into daily IONEX file including .txt files::
CREM	call submapd4(1,iyr,imn,idy1,iyr,imn,idy2)
CREM	call submapd4(2,iyr,imn,idy1,iyr,imn,idy2)
CREM	call submapd4(3,iyr,imn,idy1,iyr,imn,idy2)
CREM	call submapd4(4,iyr,imn,idy1,iyr,imn,idy2)

C??	idy2=idy1+1
C//	call subprobm(AYRI,AMNI,IDY1,IDY1)
C Add:
C??	call blet2(idy1,ADY)
C-	call subexmag(AYRI,AMNI,ADY)
C??	idy1=idy1+1
C??	 if (idy1.le.idyend) goto 200
C
Crem      imn=imn+1
C//	if ((imn.le.12).and.(iyr.ne.16)) GOTO 177
Crem	if (imn.lt.12) GOTO 200
  699 CONTINUE ! month cycle     ! MONTHHHHHHHHHHHHHHHHHHHHHHHHH

  698 CONTINUE ! Year cycle
      GOTO 102
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
    5	iend=1
  102	continue
	pause ' ' 

      STOP
	END
