C..........................................................June 2021
C
      program devgeo14smm
C........................................................Apr 2021
C W(GTEC) regarding Shubin GTEC median for 00, 15, 30,45 min 2000-2017
C
C........................................................Mar. 2021
C W(GTEC) regarding Shubin-GTEC monthly median
C
C........................................................Jan. 2019
C
C W-index for map in geogr. coords. Glat=-87.5:2.5:87.5, glong=-180:5:180.
C
C........................................................Oct. 2015
C Avoid <a> and <b> extrapolation
C........................................................June 2014
C........................................................Dec. 2013
C results => /graf/
C........................................................Nov.2012
C for JPL hourly data
C........................................................Oct. 2012
C Include subwp3 to update file of Wp index
C........................................................Apr. 2012
C Maps in IONEX format
C
C........................................................Jan. 2012
C Correct transition from month-to-month
C
C  ......................................................Dec.2011
C  Arrange subfur forecast of fcF2, hcF2, tec, Wp maps for two days ahead
C
C .......................................................Nov.2011
C
C   Call submapdy to produce daily maps of foF2, hmF2, TEC, and W-index
C........................................................Aug.2011
C For 1h_input IONEX-based TECmap files: d:\web\dtc\YY\MM\tcMMDDUT.fYY
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C Input: prec_mn (all days) into lines 1:7(last day of prec_mn) and current_mn (till given day=>8 line) for fixed UT
C
C Change+++ Produce median for 7 preceding days (instead of 27 prec days)
C
C OUTPUT : W index global map : d:\web\dtw\YY\MM\tcMMDDUT.wYR		!W(TEC)
C		 W index global map : d:\web\dfw\YY\MM\fcMMDDUT.wYR		!W(foF2)
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C
C
C T.L.Gulyaeva .................................................July 2007
C
C FORMAT from 27 prec. days
C Include logarithmic scale indices -4,  -3,    -2,    -1,0, 1,    2,    3,   4
C Equivalent to log10(TEC/TECmed)= <-.301, -.155, -.045   0,  0.45, .155, .301 >
C                              
C Ref. Gulyaeva T.L. Logarithmic scale of ionospheric disturbances,
C      Geomagn.and Aeronomy, 1996, 36, 1, 160-163, 1996.
C
      DIMENSION IM(12)
C//	+,X1(31),X2(31)
C//     +,DA(0:28,0:72,71) ! TEC 7prec_days+curr_day=8,longs=0:72,lats=71
     +,XMED(0:72,71,0:23,0:3),DEV(0:72,71) ! Median for all UT=0,...,23 (00.15,30,45 min)
C//     +,FU1(24),FU2(24)
	dimension rx(0:72)
	integer*4 IRES(0:72,71)
C//	+,idev(0:72,71)
C//	integer*2 IYR,IMN,IDY,IUT
	+,IDY1,IDY2,nndy !Maps available for idy1 to idy2
     +,imni,iyri
	CHARACTER*48 INFILE2,OUTFILE1
C//	+,OUTFILE2
	+,INFILE1  ! Read GTEC => median
	CHARACTER*2 AYR
C	CHARACTER*4 AYEAR
	+,AUT,AMN,ADY,AMM
	+,AMNI,ADY1
C//	CHARACTER*1 ft
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
      write(*,*) ' Enter YEAR: '
	read(*,*) iyear  
C+	DO 698 iyear=2011,2020
CTemp	iyear=1998
CNORM	DO 698 iyear=2000,2017
	iyr=iyear-iyear/100*100
C-	call blet4(iyear,AYEAR)
      call blet2(iyr,AYR)
CREM	AYR='15'
C-	AYR=AYEAR(3,4)
	write(*,*) AYR
   17 format (A2)
cc	write(*,17) ' YR=',ayr
	read(AYR,*) ryr
C	IYR=int(ryr)   ! current yr
	iyri=iyr
C
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
C
Crem	WRITE(*,*)' ENTER CURRENT MN'
Crem	READ(*,13) IMN
Crem	imn=01
   13 FORMAT(I2)
200   continue	  
C
C monthly cycle
C
      DO 699 imn=1,12         ! MONTHHHHHHHHHHHHHHHHHHHHHHHHH
C+      DO 699 imn=5,12         ! MONTHHHHHHHHHHHHHHHHHHHHHHHHH
  177	call blet2(imn,amn)  ! current month
C		write(*,*) AMN
	AMNI=AMN
	imni=imn
C
C//	WRITE(*,*)' ENTER IDY1,idyend'
C//	READ(*,13) IDY1,idyend
       idy1=1
	idy2=im(imn)
C

C?? 255	idy2=idy1
      call blet2(idy1,ady1)
C
	lda1=ndoy(iyr,imn,idy1)
C
C
CJPLI	outfile1='d:\web\gtc\YY\MM\wsMMDDUTMM.sYY'   ! current mn JPLI
	outfile1='d:\web\gtc\YY\MM\wqMMDDUTMM.sYY'   ! current mn UPC
c//	outfile(9:9)=ft
c//	outfile(18:18)=ft
	outfile1(12:13)=ayr
	outfile1(15:16)=amn
	outfile1(30:31)=ayr
	outfile1(20:21)=amn
C//	outfile1=outfile2
C	outfile1(18:18)='d'
C
C  Avoid input of prec. month:
crem	nnd1=idy1-6
C//      ncnt=0        ! count of days 1,2,...,7   
C//      if (idy1.ge.7) goto 230	  ! goto input of current month
C
      infile1='d:\web\gtc\YY\MN\gtMN15UTMM.sYY'    ! 's' means Shub. Gtec
	call blet2(iyr,AYR)
	call blet2(imn,AMN)
	infile1(12:13)=ayr
	infile1(15:16)=amn
	infile1(20:21)=amn
	infile1(30:31)=ayr
C start reading GTEC=median for current mon  ======================================
C
  230	continue
	nndy=im(imn)	 ! end of current month
      DO kut=0,23
	call blet2(kut,AUT)
	infile1(24:25)=aut
C
C Min cycle
C
       imin=0
       DO 330 imm=0,45,15
	call blet2(imm,AMM)
	infile1(26:27)=amm
       OPEN(10,file=infile1,action='READ')
	 DO lat=1,71
	     READ (10,107,END=239,ERR=2) (XMED(k,lat,kut,imin),k=0,72) ! READ GTEC-med
	 ENDDO
	imin=imin+1
  239	close(unit=10)
  330	 CONTINUE
	ENDDO
C
  490 format(1X,' year=',I2,' month=',I2,' day=',I2,' ut=',I2)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Two options of 15-min instant GIM-TEC
CJPLI      infile2='d:\web\dtm\YY\MM\tcMMDDUTMM.jYY'   !GIM-tec JPLI-based IONEX geogr. fo 00, 15, 30, 45 min
      infile2='d:\web\graf\dtu\YY\MM\ut\tcMMDDUTMM.uYY'   !GIM-tec UPC-based IONEX geogr. fo 00, 15, 30, 45 min
CC++
	idy=0
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy3, current month
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
      if (idy.gt.idy2) then
	goto 500 ! end of day-to-day processing 
	endif
	call blet2(idy,ADY)
CJPLI	 	infile2(12:13)=ayr
CJPLI  	infile2(30:31)=ayr
CJPLI		infile2(15:16)=amn
CJPLI 	infile2(20:21)=amn
CJPLI	infile2(22:23)=ady
	 	infile2(17:18)=ayr         !UPC
  	infile2(38:39)=ayr			   !UPC
		infile2(20:21)=amn		   !UPC
 	infile2(28:29)=amn			   !UPC
	infile2(30:31)=ady			   !UPC
	outfile1(22:23)=ady	
C++
C++  Rename file extension .re1 or ta* / tb* for prediction files
  700 format(A128)
  107	FORMAT(73(1X,F4.1))
C
C UT cycle			  +++++++++++++++++++++++
        DO 601 iut=0,23  ! UTTTTTTTTTTTTTTTTTTTTTT
	  call blet2(iut,AUT)
CJPLI	infile2(24:25)=aut
	infile2(32:33)=aut           !UPC
	outfile1(24:25)=aut	
	imin=0
C
C Minute cycle
C    		  
      DO 701,imm=0,45,15			!MINNNNNNNNNNNNNNNNN
	call blet2(imm,AMM)
CJPLI	infile2(26:27)=amm
	infile2(34:35)=amm
	outfile1(26:27)=amm	
	 
		OPEN(10,FILE=INFILE2,action='READ')
		OPEN(11,FILE=OUTFILE1)
C
 704 	 continue
       do 600 ilat=1,71		  ! < LAT-BY-LAT	LATTTTTTTTTTTTTTTTT
cr	glat=glat+2.5
	READ (10,107,END=108,ERR=2) (rx(k),k=0,72)
C
cr	glon=-185.		! TEC at glon=-180,-185,...,180
	   do 114 m=0,72		 !<<<<<<<<<<<<<<<<<< LONNNNNNNNNNNNNN
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
C Calculation of W index for idy 
      xpar=rx(m)
	xmd=XMED(m,ilat,iut,imin)
	devlog=0.
	call windex(xpar,xmd,devlog,iwind)
	DEV(m,ilat)=devlog
	IRES(m,ilat)=iwind
C-	amed=xmd
C-	if (ft.eq.'f') amed=sqrt(xmd)
C//	idev(m,ilat)=nint(dev(m,ilat)*1000.)
 114  CONTINUE        ! cycle M ~ glong		   !LONNNNNNNNNNNNNNNN
Crem 	WRITE(*,498) (IRES(K,ilat),K=0,72)
 	WRITE(11,498) (IRES(K,ilat),K=0,72)
Crem	WRITE(*,498) (IDEV(K,ilat),K=0,72)
C//	WRITE(11,498) (IDEV(K,ilat),K=0,72)
  600	CONTINUE			  !< LAT-BY-LAT			!LATTTTTTTTTTTTTTTTTT
C
C outout results+++++++++++++++++++++++++++++++++++
C
  108	close(UNIT=10)
	close(UNIT=11)
C//      close(UNIT=12)
      imin=imin+1
  701	CONTINUE  ! MINNNNNNNNNNNNNNNNNN
  601 CONTINUE			  !UTTTTTTTTTTTTTTTTTTTTTTTT
C
C
      lda=ndoy(iyr,imn,idy) ! function to define day-of-year
C
crem 	WRITE(*,498) (IMED(K,ilat),K=0,72)
c== 	WRITE(113,498) (IMED(K,ilat),K=0,72)

C	
       if (idy.lt.idy2) GOTO 499        ! NEXT DAYYYYYYYYYYYYYYYYYYYYYY	 
 150	continue         ! 
C
 498  FORMAT(73(1X,I4))
c==		CLOSE(unit=113)
C

 202  CONTINUE
C
C =========================================
  500 continue   ! end day-by-day cycle     !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C//	imn=imni

  300 CONTINUE		! end UT cycle
C Combine UT maps into daily IONEX file including .txt, .txa, .txb files:
            write(*,*) ' yr=',AYR,'  mn=',AMN,' dy1=',idy1,' dy2=',idy2 
C
  699 CONTINUE ! month cycle     ! MONTHHHHHHHHHHHHHHHHHHHHHHHHH

  698 CONTINUE ! Year cycle
      GOTO 102
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
    5	iend=1
  102	continue
	pause ' ' 

      STOP
	END
