      subroutine subextrj(fht,iyr,imn,idy,iyr_nex,imn_nex,idy_nex)
C..................................................................Nov. 2012
C for JPL data
C..................................................................Dec 2011
C produce extrapolated maps: tec, foF2, hmF2, for 1 day forward
C enter: maps for 4 prec. days, all hours UT
C re-arrange data at each grid for 96 successive hours 
C produce subfur results for 24 next hours
C combine results for 24 maps
C
C fht='f', 'h', 't' for foF2, hmF2, TEC
C iyr,imn,idy -last available date-of-maps
C jyr_nex,jmn_nex,jdy_nex - date of extrapolated maps
	DIMENSION FUA(5,24),FUB(5,24),XMAP(5,0:23,0:72,71) !5 days,UT,GLON,GLAT
	+,IM(12),rx(0:72),DAT(5,0:23),ires(0:72)
	CHARACTER*1 fht
	CHARACTER*48 INFILE1,INFILE2,OUTFILE  
		integer*2 IYR,IMN,IDY,IUT,iyr_pre,imn_pre
 	+,iyr_nex,imn_nex,idy_nex  ! next day
	+,idy_pre
	+,IDY1,nndy,kdy  ! 
	+,iyri,imni,idyi
	CHARACTER*2 AYR,AUT,AMN,ADY,PYR,PMN
	+,PDY,AMN_NEX
      COMMON /BLFUR/FUA,FUB        ! Coeff. Furie
		COMMON   /CONST/UMR
            DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	do i=1,5
	do j=0,23
	do k=0,72
	do n=1,71
	XMAP(i,j,k,n)=0.
	enddo
	enddo
	enddo
	enddo
	iyri=iyr
	imni=imn
	idyi=idy
200   continue	  
 	if (iyr.lt.90) then
 	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
 	call blet2(iyr,ayr)  ! current year
 	call blet2(imn,amn)  ! current month
 	call blet2(idy,ady)  ! current day
	lda=ndoy(iyr,imn,idy)
	 call submmdd(lda,iyr,imn,idy)
	pyr=AYR ! prec_year
	iyr_pre=iyr
	iyr_nex=iyr
C preceding month:
     	 infile1='d:\web\dts\YY\MM\tcMMDDUT.jYY'   ! preceding mn
	infile1(9:9)=fht
	infile1(18:18)=fht
	 infile2=infile1  ! current mn
	
 	infile2(12:13)=ayr
	infile2(15:16)=amn
 	infile2(28:29)=ayr
	infile2(20:21)=amn


C
C =======================================================
C   Day-to=day cycle
crem	idy1=idy-3		! start of -3 prec. days
C current day-3 days:
	lda_pre=lda-3
  220	if (lda_pre.le.0) then
	iyr_pre=iyr-1
	lda_pre=lda_pre+365
	endif
	 call submmdd(lda_pre,iyr_pre,imn_pre,idy_pre)
 	call blet2(iyr_pre,pyr)  ! prec. year
 	call blet2(imn_pre,pmn)  ! prec. month
 	call blet2(idy_pre,pdy)  ! prec. day
 	infile1(12:13)=pyr
	infile1(15:16)=pmn
 	infile1(28:29)=pyr
	infile1(20:21)=pmn

C
C Avoid input of prec. month if current day >=4
  221	if (idy.ge.4) goto 130
	nndy=im(imn_pre)
	lnndy=ndoy(iyr_pre,imn_pre,nndy)
C =======================================================
C start input of prec. month 
	icnt=0
  55	DO 77 kdy=idy_pre,nndy
	icnt=icnt+1
	lda_pre=lda_pre+1      ! count total days of prec. mn
	call blet2(kdy,ADY)
	infile1(22:23)=ADY
crem		aut='00'
crem      	read(aut,*) ut
crem		  	iut=int(ut)

C
C  day-to-day input for prec mon
C
C
C  Start cycle on UT		=======================================================================
C
C     	 infile1='d:\web\dtc\YY\MM\tcMMDDUT.fYY'   ! preceding mn
  107	FORMAT(73(1X,F4.0))		   
 
C	  UT cycle:
	DO 300 iut=0,23
	call blet2(iut,AUT)
	infile1(24:25)=aut
	OPEN(112,FILE=INFILE1)	  ! prec. month
C   reading map for prec. month
C
cr	glat=-90.
 	DO ilat=1,71,1		  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (112,107,END=108,ERR=2) (rx(k),k=0,72)
C
cr	glon=-195.		! glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
c XMAP(5,0:23,0:24,35) !5 days,UT,GLON,GLAT
	xmap(5,iut,k,ilat)=rx(k)
	enddo
	ENDDO
  300	continue
Move data day-by-day up so that last day of month nndy=>day_3:
C
	do j=1,4			  ! <day-by-day
	do iut=0,23           ! shift cycles
 	do ilat=1,71		  ! < LAT-BY-LAT
	do k=0,72			  ! all longi
C???	xmap(j-1,iut,k,ilat)=xmap(j,iut,k,ilat) ! move data one day up 
	xmap(j,iut,k,ilat)=xmap(j+1,iut,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				   ! all lati
	enddo				  ! all days
	enddo                 ! <day-by-day end shift cycle
   77	continue
  108	close(unit=112)
C
	if (icnt.eq.4) then    ! icnt
	goto 222
	           else
C
C CHECK NEXT LINES FOR CURRENT MONTH!!!!!!!!!!!!!!!
C
	if((iyr_pre.lt.iyr).and.(lda_pre.gt.int(dnr))) then
	lda_pre=lda_pre-int(dnr)
	iyr_pre=iyr
	endif
	            endif

C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C Reading current month
  130	continue

	call submmdd(lda_pre,iyr_pre,imn,idy1)
crem		kk=0
 	DO 78 kdy=idy1,idy  ! 
		call blet2(kdy,ADY)
 	infile2(22:23)=ADY
C UT cycle
	DO 301 iut=0,23
	call blet2(iut,AUT)
	infile2(24:25)=aut
	OPEN(113,FILE=INFILE2)	  ! current. month
C   reading map for  current month
C
cr	glat=-90.
 	DO ilat=1,71 	  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (113,107,END=109,ERR=2) (rx(k),k=0,72)
C
cr	glon=-195.		! glon=-180,-165,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
cr	glon=glon+15.
cr	if (glon.lt.0.) glon=glon+360.
c XMAP(5,0:23,0:24,35) !5 days,UT,GLON,GLAT
	xmap(5,iut,k,ilat)=rx(k)
	enddo
	ENDDO
  301	continue
crem      kk=kk+1
Move data day-by-day up so that last day of month nndy=>day_3:
C
	do j=1,4			  ! <day-by-day
	do iut=0,23           ! shift cycles
 	do ilat=1,71		  ! < LAT-BY-LAT
	do k=0,72			  ! all longi
C???	xmap(j,iut,k,ilat)=xmap(j+1,iut,k,ilat) ! move data one day up 
	xmap(j,iut,k,ilat)=xmap(j+1,iut,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				   ! all lati
	enddo				  ! all days
	enddo                 ! <day-by-day end shift cycle
   78	continue
  109	close(unit=113)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  222	iflag=0
	lday=lda !
  99  continue  
C Prepare grids for subfur extrapolation
	do ilat=1,71
C
	do ilon=0,72
C
	do iut=0,23
	do ii=1,4
	DAT(ii,iut)=xmap(ii,iut,ilon,ilat)
	enddo
	DAT(5,iut)=0.
	enddo
C
	call subfur4(dat)
	do iut=0,23
	xmap(5,iut,ilon,ilat)=dat(5,iut)
	enddo
C
	enddo         ! ilon cycle
C
	enddo		  ! ilat cycle
C
C  output results for idy+1:
C
      lda_nex=lda+1
	imn_nex=imn
	if (lda_nex.gt.int(dnr)) then
	iyr_nex=iyr+1
	imn_nex=1
	lda_nex=lda_nex-int(dnr)
	endif
	call submmdd(lda_nex,iyr_nex,imn_nex,idy_nex)
	call blet2(idy_nex,ady)
	call blet2(imn_nex,amn_nex)
	call blet2(iyr_nex,ayr)
		outfile=infile2
	 	outfile(12:13)=ayr
		outfile(15:16)=amn_nex
		outfile(28:29)=ayr
		outfile(20:21)=amn_nex
	outfile(22:23)=ady
 106	FORMAT(73(1X,I4))	

C cycle on UT map: 	   
 	do iut=0,23
	call blet2(iut,aut)
	outfile(24:25)=aut
C++
	ldaya=lday+1
	if (ldaya.gt.int(dnr)) ldaya=ldaya-int(dnr)
	

 	if (lda_nex.eq.ldaya) then
	outfile(19:19)='a'
	goto 181
	endif
C
	ldayb=ldaya+1
	if (ldayb.gt.int(dnr)) then
	ldayb=ldayb-int(dnr)
	iyr_nex=iyr+1
	imn_nex=1
	idy_nex=1
	endif
	if (lda_nex.eq.ldayb) outfile(19:19)='b'

  181	OPEN(12,FILE=OUTFILE)
	do ilat=1,71
	do ilon=0,72
	ires(ilon)=nint(xmap(5,iut,ilon,ilat))
	enddo
	write(12,106) (ires(k),k=0,72)  ! predic. for next day
crem	write(*,106) (ires(k),k=0,72)  ! predic. for next day
	enddo
C
	close(unit=12)
 	enddo     ! cycle on UT
C
C 	 repeat process for 2nd day
      iflag=iflag+1
C      move data up for 1 day:
C
	do j=1,4			  ! <day-by-day
	do iut=0,23           ! shift cycles
 	do ilat=1,71		  ! < LAT-BY-LAT
	do k=0,72			  ! all longi
	xmap(j,iut,k,ilat)=xmap(j+1,iut,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				   ! all lati
	enddo				  ! all days
	enddo                 ! <day-by-day end shift cycle
C
	
      lda=lda_nex
	iyr=iyr_nex
	if (iflag.le.1) then 
	goto 99
	             else
	goto 98
	endif
   2	write(*,*) 'Error reading data file', infile1,infile2
	pause ' '
	stop
  98	continue
		iyr=iyri
	 imn=imni
	idy=idyi

	RETURN
	END